//---------------------------------------------------------------------------
#include <fmx.h>
#pragma hdrstop

#include "Main.h"
#include <System.IOUtils.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.fmx"
TFormMain *FormMain;
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::PaintBoxPaint(TObject *Sender, TCanvas *Canvas)
{
  try
  {
    Canvas->BeginScene();
    // draw white background
    Canvas->ClearRect(PaintBox->ClipRect, TAlphaColorRec::White);
  }
  __finally
  {
    Canvas->EndScene();
  }

  String FileName = "";
  if (WriteSvg)
    FileName = Ioutils::TPath::Combine(Ioutils::TPath::GetDocumentsPath(), "picture.svg");

  TSvgCanvas *SvgCanvas = new TSvgCanvas(FileName, Canvas);
  try
  {
    DrawPicture(SvgCanvas);
  }
  __finally
  {
    delete SvgCanvas;
  }

  WriteSvg = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::DrawPicture(TSvgCanvas *Canvas)
{
  Canvas->BeginScene();
  try
  {
    Canvas->Stroke->Kind = TBrushKind::Solid;
    Canvas->Stroke->Thickness = 2;

    // line
    Canvas->Stroke->Color = TAlphaColorRec::Yellow;
    Canvas->DrawLine(TPointF(50, 80), TPointF(200, 80));

    // rectangle
    Canvas->Fill->Color = TAlphaColorRec::Lightgreen;
    Canvas->FillRect(TRectF(250, 50, 450, 120), 0, 0, TCorners());
    Canvas->Stroke->Color = TAlphaColorRec::Green;
    Canvas->DrawRect(TRectF(250, 50, 450, 120), 0, 0, TCorners());

    // ellipse
    Canvas->Fill->Color = TAlphaColorRec::Lightpink;
    Canvas->FillEllipse(TRectF(50, 150, 200, 220));
    Canvas->Stroke->Color = TAlphaColorRec::Red;
    Canvas->DrawEllipse(TRectF(50, 150, 200, 220));

    // triangle
    TPointF Points[3];
    Points[0] = Point(250, 220);
    Points[1] = Point(450, 220);
    Points[2] = Point(350, 150);
    Canvas->Fill->Color = TAlphaColorRec::Lightblue;
    Canvas->FillPolygon(Points);
    Canvas->Stroke->Color = TAlphaColorRec::Blue;
    Canvas->DrawPolygon(Points);
  }
  __finally
  {
    Canvas->EndScene();
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonSaveSvgClick(TObject *Sender)
{
  WriteSvg = true;
  PaintBox->Repaint();
}
//---------------------------------------------------------------------------

